"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var WechatWorkModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const wechat_work_config_1 = require("./wechat-work.config");
const services_1 = require("./services");
const middleware_1 = require("./middleware");
let WechatWorkModule = WechatWorkModule_1 = class WechatWorkModule {
    constructor(config) {
        this.config = config;
    }
    static register(config) {
        return {
            module: WechatWorkModule_1,
            providers: [
                {
                    provide: wechat_work_config_1.WechatWorkConfig,
                    useValue: config,
                },
            ],
        };
    }
    configure(consumer) {
        if (this.config.authConfig) {
            consumer
                .apply(middleware_1.WechatWorkAuthMiddleware)
                .forRoutes({ path: this.config.authConfig.loginPath, method: common_1.RequestMethod.GET }, { path: this.config.authConfig.logoutPath, method: common_1.RequestMethod.GET });
        }
    }
};
WechatWorkModule = WechatWorkModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        imports: [common_1.HttpModule],
        providers: [services_1.WechatWorkBaseService, services_1.WechatWorkContactsService, services_1.WechatWorkAuthService, wechat_work_config_1.WechatWorkConfig],
        exports: [services_1.WechatWorkBaseService, services_1.WechatWorkContactsService, services_1.WechatWorkAuthService, wechat_work_config_1.WechatWorkConfig],
    }),
    __metadata("design:paramtypes", [wechat_work_config_1.WechatWorkConfig])
], WechatWorkModule);
exports.WechatWorkModule = WechatWorkModule;
